/* 
Capacitor discharge waveform. Digital outputs are set to HIGH for one second
to charge the capacitor through a resistor. Suddenly is taken LOW and the
voltage across the capacitor is digitized several times

usage:  ( To send the output to a file and plot it)

#cap > cap.dat
#xmgrace cap.dat
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

#include "phlib.h"

#define		NP 100

int main()
{
double	t[NP], adc[NP];

int k;

if(!open_phoenix())
	{
	fprintf(stderr, "Phoenix driver open failed.\n");
	exit(1);
	}

write_outputs(255);	// LSB of digital output to HIGH
sleep(1);
write_outputs(0);	// take it low after charging

read_block(NP, 0, 0, t, adc);	// digitize the voltage NP times

for(k = 1; k < NP; ++k)  printf("%f %f\n", t[k], adc[k]);

return 0;
}

