// Measure 'g' by measuring the time of flight of a falling object
/* To compile
gcc -o ag ag.c -lphoenix -L/usr/phoenix/lib -I/usr/phoenix/include
*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "phlib.h"

int main(int argc, char *argv[])
{
double	t, height = 50.0;

if(argc == 2)
	height = atof(argv[1]);
else
	printf("Usage: ag height (cm)\n");

open_phoenix();

printf("Place steel ball below the electromagnet. h=%4.2f cm\n",height);
write_motor(15);
sleep(4);

t = clr2ftime(9,0); 

printf("c2ftime = %f\n",t);
// t = DropTime(8,0);

if(t < 0)
	{
	fprintf(stderr,"Timeout error\n");
	exit(1);
	}
	
t -= 7000;	// 7 ms  for the magnetic hysterisis
t *= 1.0e-6;		

printf("Time = %8.5f seconds.\ng = %7.2f cm/sec^2\n", t, 2.0 * height/(t*t) );
return 0;
}
