/* 
Measure time period T of a pendulum using light sensor. 
The light barrier output is HIGH normally and when the pendulum passes through
the light is stopped and it goes LOW for a while. The function 'MidHighTime'
returns the timestamp of the middle point of this pulse. We need the
difference between alternate time stamps

From 'T' can be calculated using the appropriate equation, knowing the dimensions
of the pendulum.
*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "phlib.h"

#define	NP	10

int main(int argc, char *argv[])
{
int 	k=0;
double	t1, t0, T, g, len = 17.88 + 1.27;

if(!open_phoenix())
	{
	fprintf(stderr, "Phoenix driver open failed.\n");
	exit(1);
	}

if(argc ==2)
	len = atof(argv[1]);


t0 = mid_high_time(0);

for(k=0; k<20; ++k)
	{
	t1 = mid_high_time(0);
	t1 = mid_high_time(0);

	T = (t1 - t0) / 1.0e6;
t0 = t1;
	g = 4.0 * 3.1416 * 3.1416 * len / ( T * T);
	printf("%8.6f  %6.1f\n", T , g);
	}
	
return 0;
}

