#!/bin/bash

#check whether the linux kernel source is installed. If so compile the driver
#otherwise copy the object file to /lib/modules/x.x.x/kerner/drivers/char
 
pushd /usr/src >> /dev/null
srcdir=`ls -1 | grep -m 1 linux`
if (( $? ))		#  no source installed
then
  have_sorce=0
else
  have_source=1
fi
popd >> /dev/null

kernel=`uname -r | cut -d. -f1,2`		# find linux kernel version
version=`uname -r`

if [ "$kernel" = "2.4" ]; then
   if ["$have_source" = "0"]; then
      echo "No kernel source found. Using precompiled 'phdriver.o'"
   else
      make ph24
      rm -f /lib/modules/$version/kernel/drivers/char/phdriver*	
      cp phdriver24.o /lib/modules/$version/kernel/drivers/char
   fi
elif [ "$kernel" = "2.6" ]; then
   if [ "$have_source" = "0" ]; then
      echo "No kernel source found. Using precompiled 'phdriver.ko'"
   else
      make
   rm -f /lib/modules/$version/kernel/drivers/char/phdriver*	
   cp phdriver.ko /lib/modules/$version/kernel/drivers/char
   fi
fi

depmod > /dev/null
