// User programs calling the phoenix driver must include this file

			// IOCTL Codes for different actions
#define	DIGIN		0
#define	DIGOUT		1
#define	SETDAC		2
#define	MOTORCW		3
#define	MOTORCCW	4
#define	SETMOTOR	5
#define	SELECTADC	6
#define	READADC		7
#define	READBLOCK	8
#define	MULTIREADBLOCK	9
#define	TRIGREADBLOCK	10
#define	PERIOD		11
#define	R2RTIME		12
#define	R2FTIME		13
#define	F2RTIME		14
#define	F2FTIME		15
#define	SET2RTIME	16
#define	SET2FTIME	17
#define	CLR2RTIME	18
#define	CLR2FTIME	19
#define	PULSE2RTIME	20
#define PULSE2FTIME	21
#define	PULSEOUT	22
#define	SLOWPULSEOUT	23
#define	SETMAXWAIT	24

#define ENBIRQ		30
#define IRQCOUNT	31
#define TIMESTAMP	32

#define OUTDATA		51
#define OUTCTL		52
#define INSTAT		53
#define PULSEDATA	54
#define PULSECTL	55


/* --------- Data structures and arrays used by the driver--------------
Most of the time the driver reads the analog and digital values from the
phoenix box and returns it with a time stamp. The time is returned in the
structure 'timeval' define by Linux. It has seconds and microseconds fields.
We define a structure named adcdata that contains 'timeval' and an integer
array of size 4. 32 bit integer is used eventhough ADC needs only 8 bit.
	The same structure is used by ioctl calls returning timestamps only.
In that case the field 'adval' is unused.
User programs should include the 'phdriver.h' to define the same structure
in their program and pass pointers to array of such structures to the driver. 
For examples see the program 'phlib.c'
*/

#define FALSE	0
#define TRUE	1
#define MAXPOINTS	(1 << 13)	// for ADC block read with time stamp
#define MAXDELAY	1000		// delay between adc reads
#define	MAXPULSES	100			// upto 100 bursts
#define	MAXHP		10000		// Pulse out Half Period less than 10 msec

typedef struct			// structure for data transfer
{
  struct timeval t;
  int  adval[4];
} drvdata;
