#define FALSE		0
#define TRUE		1
#define MAXPOINTS	(1 << 13)
#define MAXDELAY	1000

typedef	unsigned char boolean;
typedef unsigned char byte;

boolean open_phoenix(void);
boolean set_dac(int dat);	// int from 0 to 255		
boolean set_voltage(double mv);	// mv from -5000 to 5000
int read_inputs(void);		// returns 0 to 15. On error 255
boolean write_outputs(int dat);	// dat from 0 to 255
boolean rotate_motor(int nsteps, int dir);
boolean write_motor(int dat);	// dat from 0 to 15

boolean select_adc(int chan);	// chan from 0 to 3 (+8 to disable sampling)
int read_adc(double *ts);	// 0 to 255. On error -1. Time stamp in *ts
double zero_to_5000(void);	// 0 to 5000 mV
double minus5000_to_5000(void);	// -5000 to 5000 mV
boolean read_block
  (int npoints,  int delay, boolean bipolar,double* tstamp, double *adval);
boolean multi_read_block
  (int np, int nchan, int delay, double *t, int* a, int* b, int* c, int* d);
boolean trig_read_block(int pin, int npoints, int deadtime, int delay, 
      boolean bipolar, double* tstamp, int *adval);

double period(int bit);			// measures Period of TTL waveform
double r2rtime(int pin1, int pin2);	// pin1 rising to pin2 rising edges
double r2ftime(int pin1, int pin2);	// rising to falling
double f2rtime(int pin1, int pin2);
double f2ftime(int pin1, int pin2);
double set2rtime (int pin1, int pin2);
double set2ftime (int pin1, int pin2);
double clr2rtime (int pin1, int pin2);
double clr2ftime (int pin1, int pin2);
double pulse2rtime(int pin1, int pin2, int width, int deadtime, int pol);
double pulse2ftime(int pin1, int pin2, int width, int deadtime, int pol);

double pulse_out(int pin, int high, int low, int np, int pol);
double mid_low_time(int pin);		// Marks a negative TTL pulse
double mid_high_time(int pin);		// Marks a positive TTL pulse
int set_timeout(unsigned int usec);	// value from 5000 to 5000000
double timestamp(void);			// returns the absolute time
