/* ppilib.c -- Parallel Port for root only 18-Dec-2004 BPA */

#include <stdio.h>
#include <stdlib.h>
#include <sys/io.h>
#include <ctype.h>
#include <math.h>

typedef unsigned char	byte;

#define	DATA	0x378		/* printer port I/O addresses */
#define STAT	0x379
#define CTL	0x37A

#define	ADCLO	0               /* select different functions */
#define	ADCHI	1
#define	ADADR	2
#define	ADSTRT	3
#define	DAC	4
#define	SM	5
#define	DOUT	6
#define	DIN	7

#define ENBIT	8	/* to avoid decoder spikes */
#define ADEOC	128	/* connected to S6 of status byte */
#define FALSE	0
#define TRUE	1


void setDAC(byte dat)	/* input 0 to 255 */
{
outb(dat,DATA);		/* DAC goes from -5 to 5 for 0 to 255 */
outb(DAC, CTL);
outb(ENBIT+DAC, CTL);
outb(DAC, CTL);
outb(0,CTL);
}



main()
{
int k, v1,v2;


if(ioperm(DATA,3,1) < 0) exit(1);

setDAC(0);
printf("DAC set to 0. Should output -4.98V. (Enter to continue)\n");
getchar();

setDAC(127);
printf("DAC set to 127. Should output -20mV. (Enter to continue)\n");
getchar();

setDAC(128);
printf("DAC set to 128. Should output +20mV. (Enter to continue)\n");
getchar();

setDAC(255);
printf("DAC set to 255. Should output 4.98V. (Enter to continue)\n");
getchar();
}
