import phoenix
from Tkinter import *
import sys, time, pygrace

NP = 100
delay = 120						# delay between samples
width = 400						# diplay window dimensions
height = 300
xmin = 0
xmax = delay * NP/1000000.0     # Maximum possible x coordinate
ymin =  0.0	 	                # zero for unipolar input and -5000 for bipolar
ymax = +5000.0
xscale = width / (xmax - xmin)
yscale = height / (ymax - ymin)
phdata = []
        
p = phoenix.phoenix()
if p == None:
	root = Tk()
	Label(root,text='Error: Phoenix open failed.\n May be another program using it').pack()
	root.mainloop()
	sys.exit() 

class GUI:
	canvas = None
	trace = None
	points = []

	def __init__(self, master, width=500, height=400):
		frame = Frame(master)
		frame.pack()
		self.canvas = Canvas(frame, background="black", width=width, height=height)
#		self.trace = self.canvas.create_line(self.points)
		self.canvas.pack()
		self.b1 = Button(frame, text="Charge", command=self.charge)
		self.b1.pack(side=LEFT)
		self.b2 = Button(frame, text="Discharge", command=self.discharge)
		self.b2.pack(side=LEFT)
		self.b3 = Button(frame, text="Save", command=self.save)
		self.b3.pack(side=LEFT)
		self.b4 = Button(frame, text="Analyse", command=self.analyse)
		self.b4.pack(side=LEFT)
		self.Qb = Button(frame, text="QUIT", background="red",command=frame.quit)
		self.Qb.pack(side=RIGHT)
		
		for x in range(NP):
			self.points.append([0,0])

	def draw_graph(self):
		global NP, phdata, xscale, yscale, ymin
		for x in range(NP):
			self.points[x][0] = phdata[x][0] * xscale
			self.points[x][1] = height - (phdata[x][1] - ymin) * yscale

		self.canvas.delete(self.trace)
		self.trace = self.canvas.create_line(self.points, fill="white")
		self.canvas.pack()

	def charge(self):
		global phdata, NP, delay
		p.write_outputs(0)
		time.sleep(1)
		p.write_outputs(255)
		phdata = p.read_block(NP, delay, 0)
		self.draw_graph()
		
	def discharge(self):
		global phdata, NP, delay
		p.write_outputs(255)
		time.sleep(1)
		p.write_outputs(0)
		phdata = p.read_block(NP, delay, 0)
		self.draw_graph()
		
	def save(self):
		global  NP, phdata
		f = open('cap.dat','w')
		for i in range(NP):				# data returned by read_block goes to file
			x = phdata[i][0]
			y = phdata[i][1]
			s = str(x) + ' ' + str(y) + '\n'	
			f.write(s)	
		f.close()	

	def analyse(self):
		global NP, phdata
		pg = pygrace.grace()
		x = range(NP)
		y = range(NP)
		i = 0
		while i < NP:				# data returned by read_block goes to xmgrace
			x[i] = phdata[i][0]		
			y[i] = phdata[i][1]	
			i = i + 1
		pg.plot(x,y)

p.select_adc(0)
root = Tk()
GUI(root,width,height)
root.mainloop()
			