import phoenix, time, string
from Tkinter import *
import pygame


class App:
	screen = None
	helping = 0
	cmdstring = ""
	height = 30.0
	
	def __init__(self, master):

		frame = Frame(master)
		frame.pack()

		Label(frame, text = "Gravity Measurement").pack()

		self.res = Label(frame, text = "g = ");
		self.res.pack(side=TOP)

		self.Fbutton = Button(frame, text="FIX", command=self.fix)
		self.Fbutton.pack(side=LEFT)

		self.Dbutton = Button(frame, text="DROP", command=self.drop)
		self.Dbutton.pack(side=LEFT)

		self.Hbutton = Button(frame, text="Help", command=self.help)
		self.Hbutton.pack(side=LEFT)

		self.hlab = Label(frame, text="h=(30cm)")
		self.hlab.pack(side=LEFT)

		self.t1 = Text(frame, width=10, height=1)
		self.t1.pack(side=LEFT, expand=YES, fill ='x')
		self.t1.bind("<Key>",self.setheight)
		
		self.Hbutton = Button(frame, text="QUIT", command=frame.quit)
		self.Hbutton.pack(side=LEFT)

		
		
	def setheight(self, e):
		key = e.char[0]
		if key == '\r' and self.cmdstring != "":
			f = string.atof(self.cmdstring)
			self.hlab.config(text="h="+str(f)+"cm")
			self.cmdstring = ""	
		 	self.length = f;
		elif key == '\b':
			self.cmdstring = self.cmdstring[0:-1]
		else:
			self.cmdstring = self.cmdstring + key[0]
		
	def drop(self):
		t =  p.clr2ftime(8,0) - 7000
		t = t / 1.0e6
		x = 2.0 * 28 / (t*t)
		print t, ' ', x
		self.res.config(text=str(x))

	def fix(self):
		p.write_motor(1)


	def help(self):
		global screen
		global helping
		
		if(self.helping):
			pygame.display.quit()
			self.helping = 0
			return
		pic = pygame.image.load('/usr/phoenix/python/pics/gdirect.jpg')
		picrect = pic.get_rect()
		self.screen = pygame.display.set_mode(picrect.size)
		self.screen.blit(pic, picrect)
		pygame.display.flip()
		self.helping = 1



		
p = phoenix.phoenix()
if p == None:
	root = Tk()
	Label(root,text='Error: Phoenix open failed. May be another program using it').pack()
	root.mainloop()
	sys.exit() 

p.select_adc(0)

root = Tk()

app = App(root)

root.mainloop()

			