import phoenix
from Tkinter import *
import sys, time, pygrace

NP = 200						# Number of points to be sampled
delay = 20000					# delay between samples
width = 400						# diplay window dimensions
height = 300
xmin = 0
xmax = delay * 2 * NP/1000000.0     # Maximum possible x coordinate
ymin = -5000.0                  # This will be zero for unipolar ADC inputs
ymax = +5000.0
xscale = width / (xmax - xmin)
yscale = height / (ymax - ymin)
trig = 0
        
p = phoenix.phoenix()
if p == None:
	root = Tk()
	Label(root,text='Error: Phoenix open failed.\n May be another program using it').pack()
	root.mainloop()
	sys.exit() 

class GUI:
	canvas = None
	trace = None
	start_time = None
	index = 0
	running = False
	data = []
	points = []
	
	
	def __init__(self, master, width=500, height=400):
		self.parent  = master
		frame = Frame(master)
		frame.pack()
		self.canvas = Canvas(frame, background="black", width=width, height=height)
		self.canvas.pack()
		self.b1 = Button(frame, text="Start", command=self.start)
		self.b1.pack(side=LEFT)
		self.b3 = Button(frame, text="Save", command=self.save)
		self.b3.pack(side=LEFT)
		self.b4 = Button(frame, text="Analyse", command=self.analyse)
		self.b4.pack(side=LEFT)
		self.Qb = Button(frame, text="QUIT", background="red",command=frame.quit)
		self.Qb.pack(side=RIGHT)
		master.after(1000, self.update)
		
	def update(self):
		global NP, phdata, delay, xscale, yscale, ymin
		
		if self.running == False:
			self.parent.after(1, self.update)
			return

		d = p.read_block(2, delay, 1)		# read the ADC
		x = d[0][0] - self.start_time
		y = d[0][1]
		self.data.append([x,y])
		self.points.append(x * xscale)
		self.points.append(height - (y - ymin) * yscale)

		self.canvas.delete(self.trace)
		self.trace = self.canvas.create_line(self.points, fill="white")
		self.canvas.pack()

		self.index = self.index + 1
		if self.index > NP:
			self.running = False
		self.parent.after(1, self.update)
		
	def start(self):
		self.points = []
		self.data = []
		d = p.read_block(2, delay, 1)		# read the ADC
		self.start_time = d[0][0]			 
		self.data.append([ 0.0, d[0][1]])	# add the first data point 
		self.points.append(0.0)
		self.points.append(height - (d[0][1] - ymin) * yscale)
		self.canvas.delete(self.trace)
		self.canvas.pack()
		self.running = True
		self.index = 1						# one item already added


	def save(self):
		global  NP, phdata
		f = open('pend.dat','w')
		for i in range(NP):
			x = self.data[i][0]
			y = self.data[i][1]
			s = str(x) + ' ' + str(y) + '\n'	
			f.write(s)	
			i = i + 1
		f.close()	

	def analyse(self):
		global NP, phdata
		pg = pygrace.grace()
		x = range(NP)
		y = range(NP)
		i = 0
		while i < NP:				# data returned by read_block goes to xmgrace
			x[i] = self.data[i][0]		
			y[i] = self.data[i][1]	
			i = i + 1
		pg.plot(x,y)

p.select_adc(0)
root = Tk()
GUI(root,width,height)
root.mainloop()
			