#include "stack-c.h"
/******************************************
 * SCILAB function : openPhoenix, fin = 1
 ******************************************/

int intsopenPhoenix(fname)
   char *fname;
{
 CheckRhs(0,0);
 CheckLhs(0,1);
 /* cross variable size checking */
 C2F(openPhoenix)();
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : readInputs, fin = 2
 ******************************************/

int intsreadInputs(fname)
   char *fname;
{
 int nn1,un=1,mn1,l1;
 CheckRhs(0,0);
 CheckLhs(1,1);
 /* cross variable size checking */
 nn1=1;
 CreateVar(1,"i",(un=1,&un),(mn1=nn1,&mn1),&l1);/* named: dat */
 C2F(readInputs)(istk(l1));
 LhsVar(1)= 1;
 return 0;
}
/******************************************
 * SCILAB function : writeOutputs, fin = 3
 ******************************************/

int intswriteOutputs(fname)
   char *fname;
{
 int m1,n1,l1,mn1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable dat */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckOneDim(1,1,m1*n1,1);
 CheckVector(1,m1,n1);
 mn1=m1*n1;
 /* cross variable size checking */
 C2F(writeOutputs)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : setDAC, fin = 4
 ******************************************/

int intssetDAC(fname)
   char *fname;
{
 int m1,n1,l1,mn1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable dat */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckOneDim(1,1,m1*n1,1);
 CheckVector(1,m1,n1);
 mn1=m1*n1;
 /* cross variable size checking */
 C2F(setDAC)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : selectADC, fin = 5
 ******************************************/

int intsselectADC(fname)
   char *fname;
{
 int m1,n1,l1,mn1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable chan */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckOneDim(1,1,m1*n1,1);
 CheckVector(1,m1,n1);
 mn1=m1*n1;
 /* cross variable size checking */
 C2F(selectADC)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : readBlock, fin = 6
 ******************************************/

int intsreadBlock(fname)
   char *fname;
{
 int m1,n1,l1,mn1,m2,n2,l2,mn2,m3,n3,l3,mn3,un=1,mn4,l4,mn5,l5;
 CheckRhs(3,3);
 CheckLhs(1,2);
 /*  checking variable n */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckOneDim(1,1,m1*n1,1);
 CheckVector(1,m1,n1);
 mn1=m1*n1;
 /*  checking variable d */
 GetRhsVar(2,"i",&m2,&n2,&l2);
 CheckOneDim(2,1,m1*n1,1);
 CheckVector(2,m2,n2);
 mn2=m2*n2;
 /*  checking variable b */
 GetRhsVar(3,"i",&m3,&n3,&l3);
 CheckOneDim(3,1,m1*n1,1);
 CheckVector(3,m3,n3);
 mn3=m3*n3;
 /* cross variable size checking */
 CheckDimProp(1,2,m1*n1 != m2*n2);
 CheckDimProp(2,3,m2*n2 != m3*n3);
 CreateVar(4,"d",(un=1,&un),(mn4=*istk(l1),&mn4),&l4);/* named: t */
 CreateVar(5,"d",(un=1,&un),(mn5=*istk(l1),&mn5),&l5);/* named: v */
 C2F(readBlock)(istk(l1),istk(l2),istk(l3),stk(l4),stk(l5));
 LhsVar(1)= 4;
 LhsVar(2)= 5;
 return 0;
}
